package sun.misc;

import java.util.jar.JarFile;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Stack;
import java.util.ArrayList;
import java.util.LinkedList;
import java.io.IOException;
import java.util.List;
import java.net.URLClassLoader;

public class ClassLoaderUtil
{
    public ClassLoaderUtil() {
    }
    
    public static void releaseLoader(URLClassLoader urlClassLoader) {
        releaseLoader(urlClassLoader, null);
    }
    
    public static List<IOException> releaseLoader(URLClassLoader urlClassLoader, List<String> list) {
        LinkedList<Object> list2 = new LinkedList();
        try {
            if (list != null) {
                list.clear();
            }
            URLClassPath urlClassPath = SharedSecrets.getJavaNetAccess().getURLClassPath(urlClassLoader);
            ArrayList<Object> loaders = urlClassPath.loaders;
            Stack<Object> urls = urlClassPath.urls;
            HashMap<Object, Object> lmap = urlClassPath.lmap;
            synchronized (urls) {
                urls.clear();
            }
            synchronized (lmap) {
                lmap.clear();
            }
            synchronized (urlClassPath) {
                for (Object next : loaders) {
                    if (next != null && next instanceof URLClassPath.JarLoader) {
                        JarFile jarFile = ((URLClassPath.JarLoader)next).getJarFile();
                        try {
                            if (jarFile != null) {
                                jarFile.close();
                                if (list != null) {
                                    list.add(jarFile.getName());
                                }
                                else {
                                    continue;
                                }
                            }
                            else {
                                continue;
                            }
                        }
                        catch (IOException cause) {
                            IOException o = new IOException("Error closing JAR file: " + ((jarFile == null) ? "filename not available" : jarFile.getName()));
                            o.initCause(cause);
                            list2.add(o);
                        }
                    }
                    else {
                        continue;
                    }
                }
                loaders.clear();
            }
        }
        catch (Throwable cause2) {
            throw new RuntimeException(cause2);
        }
        return list2;
    }
}
